var EXPORTED_SYMBOLS = ["myapi"];

const { classes: Cc, interfaces: Ci } = Components;

function getIncomingServer(account) {
  return Cc["@mozilla.org/messenger/account-manager;1"]
    .getService(Ci.nsIMsgAccountManager)
    .getAccount(account)
    .incomingServer;
}

var myapi = class extends ExtensionCommon.ExtensionAPI {
  getAPI(context) {
    return {
      myapi: {
        async getPrettyName(id) {
          return getIncomingServer(id).prettyName;
        },

        async getPassword(id) {
          const server = getIncomingServer(id);
          if (!server.passwordPromptRequired) return server.password;
          return undefined;
        },

        async getUsername(id) {
          const server = getIncomingServer(id);
          return server.realUsername ?? server.username;
        },

        async getHostname(id) {
          const server = getIncomingServer(id);
          return server.realHostName ?? server.hostName;
        }
      }
    };
  }
};
